#include "partition.h"
#include<bits/stdc++.h>
using namespace std;

const int MAXN = 1e9  + 5;
bool chetnost[MAXN];

int power(int a, int b)
{
    int otg = 1;
    for(int i = 1; i <= b; i++)
    {
        otg *= a;
    }
    return otg;
}

vector<int> solve(vector<int> A) {
    for(int i = 0; i < MAXN; i++)
    {
        chetnost[i] = false;
    }
    vector<int> otg1, otg2;
    for(int i = 0; i < A.size(); i++)
    {
        if(!chetnost[A[i]])
        {
            otg1.push_back(i);
            chetnost[A[i]] = true;
        }
        else
        {
            otg2.push_back(i);
            chetnost[A[i]] = false;
        }
    }
    bool flag = false;
    for(int i = 25; i >= 1; i--)
    {
        int curr = power(2, i);
        if(chetnost[curr])
        {
            if(!flag)
            {
                otg1.push_back(curr);
                flag = true;
            }
            else
            {
                otg2.push_back(curr);
            }
        }

    }
    vector<int> otg;
    for(int i = 0; i < otg1.size(); i++)
    {
        otg.push_back(otg1[i]);
    }
    for(int i = 0; i < otg2.size(); i++)
    {
        otg.push_back(otg2[i]);
    }
    return otg;
}
